/***************************************************************************
                          apaint.h  -  description
                             -------------------
    begin                : Mon Jan 27 11:15:43 CET 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef APAINT_H
#define APAINT_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qdockwindow.h>
#include <qwidgetstack.h>

// application specific includes
#include "apaintview.h"
#include "apaintdoc.h"
#include "toolsctrl.h"
#include "widgetDrawToolbar.h"
#include "toolLine.h"
#include "toolRect.h"
#include "toolBrush.h"
#include "toolFill.h"
#include "toolSpray.h"
#include "toolElipArc.h"
#include "apaintdraw.h"
#include "apaintunredo.h"
#include "widgetPenBrushSet.h"
#include "toolSelect.h"
#include "dialogNewFile.h"
#include "toolTransform.h"
#include "dialogScaleRotate.h"
#include "dialogRepeatDimen.h"
#include "toolShiftImage.h"
#include "toolFreehandSelect.h"
#include "toolSimpleTransform.h"
#include "dialogLayerRepeat.h"
#include "toolWrite.h"
#include "dialogDrawRepeat.h"
#include "apaintdrawrepeat.h"
#include "toolStitch.h"
#include "dialogLayerSelect.h"
#include "toolZoom.h"
#include "dialogHistogram.h"
#include "widgetRuler.h"
#include "toolBezier.h"
#include "toolBSpline.h"

//Guide change
#include "widgetGuide.h"
//guide change end

#define CONTOUR_AVERAGE			0
#define GRID_PROP			1
#define HISTOGRAM_DIALOG		2
#define GUESS_WEAVE_DLG			3
#define REDUCE_SEL_BORDER		4
#define IMAGE_TO_GREYSCALE		5
#define CONTOUR_DESPECLE_ALL		6
#define CONTOUR_DESPECLE_SELECTED	7
#define FIND_REPEAT			8
#define MAKE_COLOR_SHADES		9
#define COLOR_SHORTER_INSIDE_X		10
#define COLOR_SHORTER_INSIDE_Y		11
#define COLOR_SHORTER_OUTSIDE_X		12
#define COLOR_SHORTER_OUTSIDE_Y		13
#define IKAT_X				14
#define IKAT_Y				15
#define IKAT_XY				16
#define MIX_X				17
#define MIX_Y				18
#define MIX_XY				19
#define CREATE_NOISE_XY			20
#define CREATE_NOISE_X			21
#define CREATE_NOISE_Y			22
#define TILT_RIGHT			23
#define TILT_LEFT			24
#define TILT_DOWN			25
#define TILT_UP				26
#define SPLIT_X				27
#define SPLIT_Y				28
#define JOIN_X				29
#define JOIN_Y				30
#define MOVE_LEFT			31
#define MOVE_RIGHT			32
#define MOVE_UP				33
#define MOVE_DOWN			34
#define ZIGZAG_X			35
#define ZIGZAG_Y			36
#define ZIGZAG_XY			37
#define WAVE_X				38
#define WAVE_Y				39
#define WAVE_XY				40
#define REMOVE_CONTOUR			41
#define THIN_CONTOUR			42
#define PRUNE_CONTOUR			43
#define DUPLICATE_X1			44
#define DUPLICATE_X2			45
#define DUPLICATE_X3			46
#define DUPLICATE_X4			47
#define DUPLICATE_X5			48
#define DUPLICATE_X6			49
#define DUPLICATE_X7			50
#define DUPLICATE_X8			51
#define DUPLICATE_X9			52
#define DUPLICATE_X10			53
#define DUPLICATE_Y1			54
#define DUPLICATE_Y2			55
#define DUPLICATE_Y3			56
#define DUPLICATE_Y4			57
#define DUPLICATE_Y5			58
#define DUPLICATE_Y6			59
#define DUPLICATE_Y7			60
#define DUPLICATE_Y8			61
#define DUPLICATE_Y9			62
#define DUPLICATE_Y10			63

#define CORAL_1				66
#define CORAL_2				67
#define CORAL_3				68
#define CORAL_4				69
#define CORAL_5				70
#define CORAL_6				71

#define MULTIPLY_X2			88
#define MULTIPLY_X3			89
#define MULTIPLY_X4			90
#define MULTIPLY_X5			91
#define MULTIPLY_X6			92
#define MULTIPLY_X7			93
#define MULTIPLY_X8			94
#define MULTIPLY_X9			95
#define MULTIPLY_X10			96
#define MULTIPLY_Y2			97
#define MULTIPLY_Y3			98
#define MULTIPLY_Y4			99
#define MULTIPLY_Y5			100
#define MULTIPLY_Y6			101
#define MULTIPLY_Y7			102
#define MULTIPLY_Y8			103
#define MULTIPLY_Y9			104
#define MULTIPLY_Y10			105

#define SCALE_2X			106
#define SCALE_3X			107
#define SCALE_4X			108
#define SHRINK_2X			109
#define SHRINK_3X			110
#define SHRINK_4X			111
#define HALVE_X				112
#define HALVE_Y				113
#define MIRROR_X			114
#define MIRROR_Y			115
#define SHRINK_X			116
#define SHRINK_Y			117


#define SELF_AVOID_MOTIFS1		120
#define SELF_AVOID_MOTIFS2		121
#define SELF_AVOID_MOTIFS3		122
#define SELF_AVOID_MOTIFS4		123
#define SELF_AVOID_MOTIFS5		124
#define SELF_AVOID_MOTIFS6		125
#define SELF_AVOID_MOTIFS7		126
#define SELF_AVOID_MOTIFS8		127
#define SELF_AVOID_MOTIFS9		128

#define RANDOM_MOTIFS1			130
#define RANDOM_MOTIFS2			131
#define RANDOM_MOTIFS3			132
#define RANDOM_MOTIFS4			133
#define RANDOM_MOTIFS5			134
#define RANDOM_MOTIFS6			135
#define RANDOM_MOTIFS7			136
#define RANDOM_MOTIFS8			137
#define RANDOM_MOTIFS9			138

#define PLACE_MOTIFS1			140
#define PLACE_MOTIFS2			141
#define PLACE_MOTIFS3			142
#define PLACE_MOTIFS4			143
#define PLACE_MOTIFS5			144
#define PLACE_MOTIFS6			145
#define PLACE_MOTIFS7			146
#define PLACE_MOTIFS8			147
#define PLACE_MOTIFS9			148

#define MARBLE_X			150
#define MARBLE_Y			151
#define MARBLE_XY			152

#define CONTOUR				153

#define OPEN_PDF_MANUAL			154
#define OPEN_PDF_SHORTCUTS		155
#define OPEN_PDF_FAST_PATTERN		156
#define OPEN_ARAHNE_WEB_PAGE		157

#define GRADIENT_X			158
#define GRADIENT_Y			159

#define OPEN_LICENSE_WEB_PAGE		160
#define FIND_EXACT_REPEAT		161


#define SET_LANGUAGE_CHINESE_SIMPLIFIED	200
#define SET_LANGUAGE_CHINESE_TRADITIONAL 201
#define SET_LANGUAGE_DUTCH		202
#define SET_LANGUAGE_ENGLISH		203
#define SET_LANGUAGE_FINNISH		204
#define SET_LANGUAGE_FRENCH		205
#define SET_LANGUAGE_GERMAN		206
#define SET_LANGUAGE_ITALIAN		207
#define SET_LANGUAGE_POLISH		208
#define SET_LANGUAGE_SLOVENIAN		209
#define SET_LANGUAGE_SPANISH		210
#define SET_LANGUAGE_THAI		211
#define SET_LANGUAGE_TURKISH		212


#define INVERT_COLORS_ALL		0
#define INVERT_COLORS_RED		1
#define INVERT_COLORS_GREEN		2
#define INVERT_COLORS_BLUE		3
#define INVERT_COLORS_CYAN		4
#define INVERT_COLORS_YELLOW		5
#define INVERT_COLORS_MAGENTA		6
#define INVERT_COLORS_GREY		7
#define INVERT_COLORS_SATURATION	8

#define SWAP_COLORS_RGB_GBR		9
#define SWAP_COLORS_RGB_BRG		10
#define SWAP_COLORS_RG			11
#define SWAP_COLORS_RB			12
#define SWAP_COLORS_GB			13
#define SWAP_COLORS_SL			14
#define SWAP_COLORS_PALETTE		15

#define SORT_COLORS_POPULARITY		0
#define SORT_COLORS_HUE			1
#define SORT_COLORS_SATURATION		2
#define SORT_COLORS_LIGHTNESS		3
#define SORT_COLORS_SIMILARITY		4

#define ALIGN_LEFT			0
#define ALIGN_RIGHT			1
#define ALIGN_TOP			2
#define ALIGN_BOTTOM			3
#define ALIGN_CENTER_X			4
#define ALIGN_CENTER_Y			5

#include <set>

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class ApaintView is
  * created which creates your view.
  */
class SprayPropWid;
class BSplineTool;
class ColPaletteDlg;
class QTabWidget;
class IconViewDlg;
class LayerMoveTool;
class UnselectTool;
class CleanupTool;
class DialogContour;
class CleanupProp;
class ColNumDlg;
class ReduceColorDlg;
class ColorRemapDialog;
class ApaintIO;
class InsertRemovePixelsTool;
class InsertRemovePixelsDialog;
class GuessWeaveDialog;
class PrintDialog;
class BrushListWidget;
class FillToolProp;
class MagicWandTool;
class MagicToolProp;
class VerticalyAlignedWidget;
class LayerSelSimpleWid;
class UnRedoTool;
class CommonProp;
class FreeTransformTool;
class FreeTransformDialog;
  
class ApaintApp : public QWidget
{
  Q_OBJECT
  
  public:
    /** construtor */
    ApaintApp();
    /** destructor */
    ~ApaintApp();
    /** initializes all QActions of the application */
    void initActions();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();
    /** this creates the toolbars. Change the toobar look and add new toolbars in this
     * function */
    void initToolBar();

    void initMainObjects();
    /** setup the document*/
   
    void initConnections();
    
      /** overloaded for Message box on last window exit */
    int queryExit();

    int queryRevert();

    bool transparentMove() const;
    bool transparentPaste() const;
    bool transparentSelection(void*) const;
    void selectionMoving(bool, void*);
//    void selectionPasting(bool, void*);
    void transparentButtonToggled();
    void alignSelection(int align);
    void moveSelectionX(int pos);
    void moveSelectionY(int pos);
    bool antialiasView() const;
    bool repeatDelimiterView() const;
    QRgb getFgColor();
    QRgb getBgColor();
    bool crossHairCursor() const;
    bool keepOriginalColormap() const;
    QSize getTotalSize() const;
    QSize getWindowSize() const;

  public slots:

    void emptyUndo(bool);
    void emptyRedo(bool);
    void layerOp();
    void documentChanged(bool);
    void hasBrushes(bool);

    /** generate a new document in the actual view */
    void slotFileNew();
    /** open a document */
    void slotFileBrowse();
    void slotFileOpen();

    void slotRecent();
    void slotRecentFile(int);
    void slotRecentLayer(int);

    void slotLayerLoad();
    void slotLayerBrowse();

    void slotLayerNew();
    void revertToSaved();
    /** save a document */
    void slotFileSave();
    /** save a document under a different filename*/
    void slotFileSaveAs();
    void slotFilePrint();
    
    void slotFileQuit();
    
    void slotEditUndo();
    
    void slotEditRedo();
    /** put the marked text/object into the clipboard and remove
     * it from the document */
    void slotEditCut();
    /** put the marked text/object into the clipboard*/
    void slotEditCopy();
    /** paste the clipboard into the document*/
    void slotEditPaste();
    void slotEditMultiplePaste();
    void slotEditSelectAll();
    void slotEditDelete();
    void slotEditClear();
    void slotEditScale();
    void slotColorsPopylarity();
    void slotColorsHue();
    void slotColorsSaturation();
    void slotColorsLightness();
    void slotColorsSimilarity();
    void slotColorCountHorizontal();
    void slotColorCountVertical();
    void slotColorInvertProtected();
    void slotColorClearProtected();
    void slotColorInvertTransparent();
    void slotColorClearTransparent();
    void slotColorEdit();

    void slotColorInvertAll();
    void slotColorInvertRed();
    void slotColorInvertGreen();
    void slotColorInvertBlue();
    void slotColorInvertCyan();
    void slotColorInvertYellow();
    void slotColorInvertMagenta();
    void slotColorInvertGrey();
    void slotColorInvertSaturation();
    
    void slotColorSwapPalette();
    void slotColorSwapRGB_GBR();
    void slotColorSwapRGB_BRG();
    void slotColorSwapRG();
    void slotColorSwapRB();
    void slotColorSwapGB();
    void slotColorSwapSL();

    void slotContrastStretch();
    void slotFindRepeat();
    void slotFindExactRepeat();
    void slotDuplicateX1();
    void slotDuplicateX2();
    void slotDuplicateX3();
    void slotDuplicateX4();
    void slotDuplicateX5();
    void slotDuplicateX6();
    void slotDuplicateX7();
    void slotDuplicateX8();
    void slotDuplicateX9();
    void slotDuplicateX10();
    void slotDuplicateY1();
    void slotDuplicateY2();
    void slotDuplicateY3();
    void slotDuplicateY4();
    void slotDuplicateY5();
    void slotDuplicateY6();
    void slotDuplicateY7();
    void slotDuplicateY8();
    void slotDuplicateY9();
    void slotDuplicateY10();
    void slotScale2X();
    void slotScale3X();
    void slotScale4X();
    void slotShrink2X();
    void slotShrink3X();
    void slotShrink4X();
    void slotHalveX();
    void slotHalveY();
    void slotShrinkX();
    void slotShrinkY();
    void slotMultiplyX2();
    void slotMultiplyX3();
    void slotMultiplyX4();
    void slotMultiplyX5();
    void slotMultiplyX6();
    void slotMultiplyX7();
    void slotMultiplyX8();
    void slotMultiplyX9();
    void slotMultiplyX10();
    void slotMultiplyY2();
    void slotMultiplyY3();
    void slotMultiplyY4();
    void slotMultiplyY5();
    void slotMultiplyY6();
    void slotMultiplyY7();
    void slotMultiplyY8();
    void slotMultiplyY9();
    void slotMultiplyY10();
    void slotColorTrueToCmap();
    void slotColorCmapToTrue();
    void slotLoadColormap();
    void slotLoadColormapDither();
    void slotToolsContour();
    void slotContourThin();
    void slotContourRemove();
    void slotContourPrune();
    void slotToolsFlatten();
    void slotViewRepeat();
    void slotFiltersRepeatLast1();
    void slotFiltersRepeatLast10();
    void slotFiltersContourAverage();
    void slotFiltersContourDespecleAll();
    void slotFiltersContourDespecleSelected();
    /** toggle the toolbar*/
    void slotViewToolBar(bool toggle);
    /** toggle the statusbar*/
    void slotViewStatusBar(bool toggle);
    
    void showViewGrid(bool toogle);
    void showRepeatDlg();
    
    /** shows an about dlg*/
    void slotHelpAbout();

    void slotShowCaption(double zx, double zy);

    void zoomInBtnClicked();
    void zoomOutBtnClicked();

    void menuActivated(int indx);
    
    void layerChangedSlot(Layer *sel);
    void toolsDialogCloseSlot();
    void showColorRemapDialog();
    void showColNumDlg();
    void showReduceColDlg();
    void insertColor(QRgb rgb, int num);
    void showDocCaption();
    void newDocSlot();
    void setGridProp();
    void layerMovedSlot(QRect pos);
    void slotLayerSave();
    void setFatLines(bool enable);
    void lineSizeChgSlot(const QPen& pen);
///Guide change
    void slotRemoveGuides();
///Guide change end
    void setRepeatMode(bool enable);
    void clipBChanged();
    void setSizeCaption(QRect size);
    void viewSizeChanged(int w, int h);
    void viewMoving(int x, int y);
    void loadLayerFile(QString& fname);
    void protectLayer(bool enable);
    void setImagePath(QString path);
    QString getImagePath() { return imgPath; };
    int rulerOn() { return shRuler->isOn(); };
    void browseBrushSlot();
    void loadBrushSlot();
    void loadBrushFile(QString &fname);
    void loadDocSlot(QString &fname);
    void layerToBrushSlot();
    void brushToLayerSlot();
    void selectByColorSlot();
    void setAntialiasView(bool enable);
    void setRepeatDelimiterView(bool enable);
    void setIntegerView(bool enable);
    void setCrosshairView(bool enable);
    void setKeepOriginalCmap(bool enable);
    void setAspectRatioDraw();
    void invertLayer();
    void imageResize();
    void imageRotate();

    ///Guide change
    void rulerClicked(QPoint*, Orientation);
    ///Guide change end
    
  protected slots:    
    void mouseMoveSlot(QMouseEvent *e, QPainter *p);
    void showRuler(bool enable);
    void rulerStyleChanged(Ruler::MetricStyle style);
    void slotAspectChanged(double fx, double fy);
    void InsRemDlgClose();

    
  protected:
    void keyPressEvent( QKeyEvent *e );
    void closeEvent(QCloseEvent *e);
    
  private:
    bool doStuffOnExit();
    bool canLoadNewDoc();

    std::set<void*> selectionInMoving;
    std::set<void*> selectionInPasting;
   
    /** view is the main widget which represents your working area. The View
     * class should handle all events of the view widget.  It is kept empty so
     * you can create your view according to your application's needs by
     * changing the view class.
     */
    ApaintView *view;
    /** doc represents your actual document and is created only once. It keeps
     * information such as filename and does the serialization of your files.
     */
    ApaintDoc *doc;

    ApaintDraw *draw;
    ApaintUnRedo *unredo;

    /*create tool container*/
    ToolsCtrl *tCtrl;
    
    /** file_menu contains all items of the menubar entry "File" */
    QPopupMenu *fileMenu;
    /** edit_menu contains all items of the menubar entry "Edit" */
    QPopupMenu *editMenu;
    /** image_menu contains all items of the menubar entry "Image" */
    QPopupMenu *imageMenu;
    /** view_menu contains all items of the menubar entry "View" */
    QPopupMenu *viewMenu;
    /** view_menu contains all items of the menubar entry "Help" */
    QPopupMenu *helpMenu;
    /** the main toolbar */    
    QPopupMenu *fileRecent;
    QPopupMenu *layerRecent;
    
    QToolBar *fileToolbar;
    QMenuBar *mBar;
    QStatusBar *statusBar;

    QPopupMenu *colorMenu, *sortColorsMenu, *duplicateXMenu, *duplicateYMenu, *multiplyXMenu, *multiplyYMenu, *smoothMultiplyMenu, *smoothShrinkMenu, 
               *countColorsMenu, *convertMenu, *protectedColorsMenu, *transparentColorsMenu,
               *toolsMenu, *filtersMenu, *noiseMenu, *ikatMenu, *selfAvoidingMotifsMenu, *randomMotifsMenu, *placeMotifsMenu, *colorShorterInsideMenu, *colorShorterOutsideMenu,
	       *repeatLastMenu, *marbleMenu, *saveSetupMenu,
	       *colorInvertMenu, *colorSwapMenu, *mixMenu, *zigzagMenu, *waveMenu, *coralMenu, *mirrorMenu, *gradientMenu, *despecleMenu, *viewMode, *viewDlg;
    /* actions for the application initialized in initActions() and used to en/disable them
       according to your needs during the program */
    
    QAction *fileNew;
    QAction *fileOpen;
    QAction *loadLayer, *saveLayer;
    QAction *fileSave;
    QAction *fileSaveAs;
    QAction *fileQuit;

    QAction *editUndo;
    QAction *editRedo;
    QAction *editCut;
    QAction *editCopy;
    QAction *editPaste, *editPasteMultiple;
    QAction *editSelectAll, *editDelete;
    QAction *fileDocumentBrowse;
    QAction *fileReload;
    QAction *fileBrowseLayer;
    QAction *filePrint;
    QAction *editClear;
    QAction *editScale;
    QAction *colorNum;
    QAction *colorReduce;
    QAction *colorRemap;
    QAction *colorCountHorizontal;
    QAction *colorCountVertical;
    QAction *sortColorsPopularity;
    QAction *sortColorsHue;
    QAction *sortColorsSaturation;
    QAction *sortColorsLightness;
    QAction *sortColorsSimilarity;
    QAction *colorInvertProtected;
    QAction *colorClearProtected;
    QAction *colorInvertTransparent;
    QAction *colorClearTransparent;
    QAction *colorEdit;

    QAction *colorInvertAll;
    QAction *colorInvertRed;
    QAction *colorInvertGreen;
    QAction *colorInvertBlue;
    QAction *colorInvertCyan;
    QAction *colorInvertYellow;
    QAction *colorInvertMagenta;
    QAction *colorInvertGrey;
    QAction *colorInvertSaturation;

    QAction *colorSwapPalette;
    QAction *colorSwapRGB_GBR;
    QAction *colorSwapRGB_BRG;
    QAction *colorSwapRG;
    QAction *colorSwapRB;
    QAction *colorSwapGB;
    QAction *colorSwapSL;

    QAction *contrastStretch;
    QAction *findRepeat, *findExactRepeat;
    QAction *duplicateX1, *duplicateX2, *duplicateX3, *duplicateX4, *duplicateX5, *duplicateX6, *duplicateX7, *duplicateX8, *duplicateX9, *duplicateX10;
    QAction *duplicateY1, *duplicateY2, *duplicateY3, *duplicateY4, *duplicateY5, *duplicateY6, *duplicateY7, *duplicateY8, *duplicateY9, *duplicateY10;
    QAction *scale2X, *scale3X, *scale4X;
    QAction *shrink2X, *shrink3X, *shrink4X;
    QAction *halveX, *halveY;
    QAction *shrinkX, *shrinkY;
    QAction *multiplyX2, *multiplyX3, *multiplyX4, *multiplyX5, *multiplyX6, *multiplyX7, *multiplyX8, *multiplyX9, *multiplyX10; 
    QAction *multiplyY2, *multiplyY3, *multiplyY4, *multiplyY5, *multiplyY6, *multiplyY7, *multiplyY8, *multiplyY9, *multiplyY10; 
    QAction *colorTrueToCmap;
    QAction *colorCmapToTrue;
    QAction *loadColormap;
    QAction *loadColormapDither;
    QAction *toolContour;
    QAction *toolContourRemove;
    QAction *toolContourThin;
    QAction *toolContourPrune;
    QAction *toolInvert;
    QAction *toolFlatten;
    QAction *toolBrushToLayer;
    QAction *toolLayerToBrush;
    QAction *viewRepeat;
    QAction *filtersRepeatLast1, *filtersRepeatLast10;
    QAction *filtersContourAverage;
    QAction *filtersContourDespecleAll;
    QAction *filtersContourDespecleSelected;
    QAction *imgRotate, *imgResize;   
    
    QAction *zoomInBtn;
    QAction *zoomOutBtn;
    QAction *viewToolBar;
    QAction *viewStatusBar;
    QAction *sgrid;
    QAction *repeatd;
///Guide change
    QAction *removeGuides;
///Guide change end
    QAction *repeatView;
    QAction *helpAboutApp;
    QAction *shRuler;
    QAction *selByColor;
    QAction *viewAntialias;
    QAction *viewRepeatDelimiter;
    QAction *viewInteger;
    QAction *viewCrosshair;
    QAction *keepOriginalCmapAct;

    QString fileName;

    DrawToolBar *drawToolBar;
    LineTool    *lineTool;
    StraightLineTool    *straightLineTool;
    BezierTool  *bezierTool;
    LineTool	*measureTool;
    RectTool    *circleTool;
    RectTool    *ellipseTool;
    RectTool    *rectTool;
    RectTool    *quadTool;
    BrushTool   *brushTool;
    FillTool    *fillTool;
    LineTool    *pLineTool;
    SprayTool   *sprayTool, *mixTool;
    SprayPropWid *sprayProp;
    ElipArcTool *eArcTool;
    QWidget *dockWin;
    PenBrushUtil *pbUtil;
    QWidget *cbContainer;
    PenBrushSet *pbSet;
    SelectTool *selTool;
    FreeHandSelect *freehand;
    TransformTool *transTool;
    NewFileDlg *nfile;
    ScaleRotDialog *srot;
    RepeatDimDlg *repDim;
    ShiftImageTool *hshift, *vshift;
    ColNumDlg *cnDlg;
    ReduceColorDlg *rcDlg;
    ColorRemapDialog *colRemapDialog;
    SimpleTransformTool *mirrorxTool, *mirroryTool, *flipTool, *explodeTool;
    QString label, imageName;
    QRect imageSize, selectionSize;
    int imageScale;
    QString imgPath;
    MultiplePasteDlg *mpasteDlg;
    WriteTool *writeTool;
    GridPropDlg *gridProp;
    QFileDialog *fileDlg;
    DrawingInRepeatDlg *repeatDlg;
    DrawInRepeat *drawRep;
    int lineSize;
    StitchTool *stTool;
    StitchPropWid *stProp;
    LayerSelDlg *layerSel;
    LayerSelSimpleWid *layerSelSimple;
    ZoomTool *zoomin, *zoomout;
    QClipboard *clipB;
    HistogramDlg *histoDlg;
    BSplineTool *bsTool;
    ColPaletteDlg *colP;
    QTabWidget *toolTab;
    Ruler *vruler, *hruler;
    QGridLayout *centralContainer;
    QWidget *centralWidget;
    RulerInfo *rInfo;
    bool swRuler;
    bool mainLayerLoaded;
    bool undoRedoEnable;
    IconViewDlg *iconDlg;
    LayerMoveTool *lMoveTool;
    UnselectTool *unselTool;
    QFont smallFont;
    QMessageBox *aboutBox;
    PropObject *pSpray, *pStitchTool, *pCleanup, *pBrushProp, *pFillProp, *pMagicWand,
    *pMeasureProp, *pSelectProp, *pBezierProp, *pBSplineProp;
    PropObject *pRectProp, *pCircleProp, *pEllipseProp, *pQuadProp;
    DialogContour *dlgContour;
    CleanupTool *cleanTool;
    CleanupProp *cleanupProp;
    InsertRemovePixelsTool *insRemPixTool;
    InsertRemovePixelsDialog *dlgInsRemPix;
    GuessWeaveDialog *gweaveDlg;
    PrintDialog *printDlg;
    BrushListWidget *bListWid;
    BrushToolProp *brushProp ;
    FillToolProp *fillProp;
    MagicWandTool *magicWandTool;
    MagicToolProp *magicWandProp;
    MeasureToolProp *measureToolProp;
    BezierToolProp *bezierProp;
    SelectProp *selectProp;
    RectProp *rectProp, *circleProp, *ellipseProp, *quadProp;
    VerticalyAlignedWidget *vertWid;
    ToolBase *dummyTool, *saveTool;
    UnRedoTool *undoTool, *redoTool;
    CommonProp *cProp;
    FreeTransformTool *freeTransTool;
    FreeTransformDialog *fdlg;
    bool multipleLayers;
    bool canPaste;
    bool canUndo;
    bool canRedo;
    bool crossHair;
    bool keepOriginalCmap;
    int lastOperation;
};

extern ApaintApp *apaint;

#endif 

