/***************************************************************************
                          apaintimageUtil.h  -  description
                             -------------------
    begin                : Mon Mar 22 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef APAINTIMAGEUTIL_H
#define APAINTIMAGEUTIL_H

#include "apaintimage.h"
#include <qsize.h>
#include <qcolor.h>
#include <qfont.h>


class ApaintImageUtil
{
public:
  static void filterApply(ApaintImage& img, bool *protColors, bool doRepeat, int what, int fgCol, int bgCol, int penX, int penY, int value, bool doVarColors, bool doVarSize, bool doGradient);
  static void averageContour(ApaintImage& img, bool *protColors, bool doRepeat, int radius, double aspectX, double aspectY);
  static void averageContour24thickness(ApaintImage& img, bool doRepeat, int thickX, int thickY);
  static void averageContourThickness(ApaintImage& img, bool *protColors, bool doRepeat, int thickX, int thickY);
  static void despecleContour(ApaintImage& img, bool *protColors, bool doRepeat, int what, int neighbours);

  static void filterApply(ApaintImage& img, int xin, int yin, int w, int h, bool *protColors, bool doRepeat, int what, int fgCol, int bgCol, int penX, int penY, int value, bool doVarColors, bool doVarSize, bool doGradient);
  static void averageContour(ApaintImage& img, int xin, int yin, int w, int h, bool *protColors, bool doRepeat, int radius, double aspectX, double aspectY);
  static void averageContour24thickness(ApaintImage& img, int xin, int yin, int w, int h, bool doRepeat, int thickX, int thickY);
  static void averageContourThickness(ApaintImage& img, int xin, int yin, int w, int h, bool *protColors, bool doRepeat, int thickX, int thickY);
  static void despecleContour(ApaintImage& img, int xin, int yin, int w, int h, bool *protColors, bool doRepeat, int what, int neighbours);
  static void contourThick(ApaintImage& img, uint rmcol, int direction, bool *protColors, int timesX, int timesY, int angle, bool doRepeat, bool doShade, bool doLines,
  	bool doGradient, bool doBidirectional, bool repeatOperation);
  static void contourRemove(ApaintImage& img, uint rmcol, bool *protColors, bool doRepeat);
  static void contourPrun(ApaintImage& img, uint rmcol, bool *protColors, bool doRepeat);
  static void contourThin(ApaintImage& img, int colInd, bool doRepeat);
  static void contourAdd(ApaintImage& img, uint rmcol, uint cmpcol, uint withCol, bool useWithCol, int direction, bool into, bool *protColors, bool doRepeat, bool doShade, int numX, int numY);
  static void insertRemovePixelsHor(ApaintImage& img, int num, int xpos, uchar colIndx, QRgb col,
                                    bool doInsert, bool useDataBuf, uchar *dataBuf);
  static void insertRemovePixelsVert(ApaintImage& img, int num, int ypos, uchar colIndx, QRgb col,
                                     bool doInsert, bool useDataBuf, uchar *dataBuf);
  static uchar *getVertLines(ApaintImage *img, int pos, int num, int &bufSize);
  static uchar *getHorLines(ApaintImage *img, int pos, int num, int &bufSize);
  static ApaintImage getTextImage(int wid, int hei, QFont font, QString text, QRgb bg, QRgb fg, bool doAntiAlias);
  static ApaintImage getTextImage(int wid, int hei, QFont font, QString text, bool doAntiAlias);
  static int getLightestColor(QRgb *ctab, int num);
  static bool qPixmapToImage(QPixmap &pixRect, ApaintImage &outImage, int xs, int ys, int wids, int heis, uint fgCol);  
  static ApaintImage getColorsImage(ApaintImage &img, QFont font, int wid, int hei);
  static bool getBgFgColors(ApaintImage &img, uint &bg, uint &fg);
  static ApaintImage doContourCleanup(ApaintImage &img, uint bg, uint fg);
  static ApaintImage changeToColorTabImg(ApaintImage &orig, ApaintImage &trueColImg,
                                         double angle, int dstWid, int dstHei, bool rotateContour,
                                         bool usingMask, QImage& mask);
  static int getClosestColor(QRgb col, int *indxTab, int numIndx, QRgb *ctab);
  static QImage getMaskByColor(ApaintImage &img, uchar colIndx, QRect &area);
private:
  static bool drawMotif(ApaintImage& img, int w, int h, bool *protColors, int what, int drawColor, int dropX, int dropY, int sizeX, int sizeY, bool drawIfPlace);
  static void makeWaveTable(int *offsetTable, int size, int valueOffset, int maxOffset, int numWaves, bool doGradient, bool doIkat, bool doMarble, bool doZigzag, bool doWave);
};

#endif
