/***************************************************************************
                          dialogIconView.h  -  description
                             -------------------
    begin                : Tue Jan 6 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ICONLISTVIEW_H
#define ICONLISTVIEW_H
#include "dialog_ui_iconView.h"
#include <qdir.h>

class IconList;
class ApaintDoc;
class IconData;
  

class IconViewDlg: public IconViewDialogUI
{
  Q_OBJECT
public:
   IconViewDlg(QWidget *parent, const char *name, ApaintDoc *docp);
   ~IconViewDlg();

   enum LoadType { MainImage=0, LayerImage, ColorPImage, BrushImage, ColormapImage, ColormapDitherImage};
   
   void showDlg(QString startDir, LoadType ltyp);
   QString getCurDir(){ return curDir;}
   void setFont(QFont& nfont);
  // fills comboBoxPath with history paths
  void setDirectoryHistoryList(const QStringList& directoryList);

signals:
   void  loadDocSig(QString &fname);
   void  loadLayerSig(QString& fname);
   void  loadColorPImage(QString &fname);
   void  loadColormapImage(QString &fname);
   void  loadColormapDitherImage(QString &fname);
   void  loadBrushSig(QString &fname);
   void  setImagePathSig(QString path);
   
public slots:
   void iconSelectedSlot();
   void updateDialog();
   void filterTextChanged(const QString& s);
   void deleteImage();
   void renameImage();
   // slot for handling user input or choice in combo box
   void comboPathChanged(int index);
   
protected slots:
   void okBtnClicked();
   void closeBtnClicked();   
   void showRepeat(bool enable);
   void showIconName(bool enable);
   void showIconSuffix(bool enable);
   void showIconSize(bool enable);
   void showFileSize(bool enable);
   void showDTime(bool enable);
   void showDirInfo(bool enable);
   void showDirectory(bool enable);
   void sortIcons(int typ);
   void showFilter(bool enable);
   void filter1Changed(int val);
   void filter2Changed(int val);
   void filter3Changed(int val);
   void filter4Changed(int val);
   void dirUpBtnClicked();
   void reloadBtnClicked();
   void homeBtnClicked();
   void renameBtnClicked();
   void deleteBtnClicked();
   void subDirClicked();
   void openWithPaintBtnClicked();

private:
 void setupData(QString newDir);
 void setupDataWithNewDir(QString newDir);
 void setupGUI();
 void setSubDirIcon();

 QString curDir;
 QDir dir;
 IconList *iList;
 ApaintDoc *doc;
 bool swFilter;
 LoadType ltype;
 QString captionStr;
 QString homeDir;
};

#endif
