/***************************************************************************
                          newfiledlg.cpp  -  description
                             -------------------
    begin                : sre apr 23 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 
#include "dialogNewFile.h"
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include "apaintconfig.h"
#include <qradiobutton.h>

NewFileDlg::NewFileDlg(QWidget *parent, const char *name, bool modal, ApaintDoc *pdoc, PenBrushUtil *pbUtilp):NewFileDialogUI(parent, name, modal)
{
  connect( OkBtn, SIGNAL( clicked() ), this, SLOT( okBtnClick()) );
  connect( CancelBtn, SIGNAL( clicked() ), this, SLOT( cancelBtnClick()) );
  connect( bgColorDepth, SIGNAL(clicked(int)), this, SLOT(colorDepthSlot(int)));
  connect( bgFillType, SIGNAL(clicked(int)), this, SLOT(colorFillType(int)));
  setCaption(ApaintConfig::getText(NEW_PICTURE_MSG));
  gbSize->setTitle(ApaintConfig::getText(SIZE_MSG));
  hightLabel->setText(ApaintConfig::getText(HEIGHT_MSG)+":");
  widthLabel->setText(ApaintConfig::getText(WIDTH_MSG)+":");
  bgColorDepth->setTitle(ApaintConfig::getText(COLOR_DEPTH));
  rbColorPalette->setText(ApaintConfig::getText(COLOR_PALETTE));
  rbTrueColor1->setText(ApaintConfig::getText(TRUE_COLOR));
  bgFillType->setTitle(ApaintConfig::getText(614));
  rbFg->setText(ApaintConfig::getText(615));
  rbBg->setText(ApaintConfig::getText(616));
  rbWhite->setText(ApaintConfig::getText(199));
  OkBtn->setText(ApaintConfig::getText(OK_MSG));
  CancelBtn->setText(ApaintConfig::getText(CANCEL_MSG));
  width = 1200;
  height = 800;
  setStartVal();
  Q_CHECK_PTR(pbUtilp);
  pbUtil = pbUtilp;
  doc = pdoc;
}

NewFileDlg::~NewFileDlg()
{
  
}

void NewFileDlg::getNewLayer()
{
  int ret;

  setStartVal();
  ret = exec();

  width=wid->value();
  height=hei->value();

  if (ret == Accepted)
  {
   doc->newLayer(width, height, imgDepth(), fillColor(), 15);
  }
}

void NewFileDlg::getNewFile()
{
  int ret;

  setStartVal();
  ret = exec();

  width=wid->value();
  height=hei->value();

  if (ret == Accepted)
  {
   doc->newDoc(width, height, imgDepth(), fillColor(), 15);
  }
  
}

void NewFileDlg::setStartVal()
{
  colDepth = bgColorDepth->id(bgColorDepth->selected());
  fillType = bgFillType->id(bgFillType->selected());
  if (!wid->value())
   wid->setValue(width);
  if (!hei->value())
   hei->setValue(height);
}

void NewFileDlg::okBtnClick()
{
 accept();
}

void NewFileDlg::cancelBtnClick()
{
  reject();
}

void NewFileDlg::colorDepthSlot(int i)
{
  colDepth = i;
}

void NewFileDlg::colorFillType(int i)
{
  fillType = i;
}

uint NewFileDlg::fillColor() const
{ 
  switch (fillType)
  {
   case 1:return(pbUtil->foreground());
   case 2: return(pbUtil->background());
   case 3: return(qRgb(255, 255, 255));
  }
  return qRgb(255, 255, 255);
}

int NewFileDlg::imgDepth()
{
  switch(colDepth)
  {
    case 0:
     return(8);
     break;
     
    case 1:
     return(32);
     break;
  }
  return 8;
}

int NewFileDlg::imgWidth()
{
 return width;
}

int NewFileDlg::imgHeight()
{
  return height;
}




