/***************************************************************************
                          cleanupTool.h  -  description
                             -------------------
    begin                : et feb 26 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef CLEANUPTOOL_H
#define CLEANUPTOOL_H
#include "toolbase.h"
#include "dialog_ui_cleanupProp.h"
#include <qspinbox.h>

class DrawInRepeat;
class ApaintDoc;



class CleanupProp: public CleanupPropDialogUI
{
  Q_OBJECT
 public:
   CleanupProp(QWidget *parent, const char *name);
   ~CleanupProp(){};

   int getAverageDiameter(){ return sbAverage->value();}
   int getDrawDiameter(){return sbDraw->value();}

protected slots:
   void updateAverage(int val);
   void updateDraw(int val);
private:
   void enableAverage(bool enable);
   
};

class CleanupTool: public ToolBase {
public:
   CleanupTool(DrawInRepeat *drawp, ToolType type, ApaintDoc *docp, PropObject *propObj);
   ~CleanupTool(){};

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void drawPointer(QPainter *p, int x, int y);
 virtual void begin();
 virtual void end();


private:
 void cleanUp(QPainter *p, int xin, int yin, int rout, int rin, ApaintImage &img, bool final, bool *pColors, QRect layerPos);
 uint getAverageColor(int xin, int yin, QRect area, int r, ApaintImage &img);
 void changeAreaToColor(int xin, int yin, uint col, QRect area, int r, ApaintImage& img, bool *pColors);
 int colLen(uint c1, uint c2);
 
 bool btnPressed;
 DrawInRepeat *draw;
 ApaintDoc *doc;
 CleanupProp *cProp;
 bool doBorder, doSmooth, aspectDrawSetting;
 uchar bIndex[2];
 
};  

#endif

