/***************************************************************************
                          stitchtool.h  -  description
                             -------------------
    begin                : Thu Oct 16 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STITCHTOOL_H
#define STITCHTOOL_H

#include <toolbase.h>
#include <qimage.h>
#include <qcolor.h>
#include <qpainter.h>
#include <qspinbox.h>
#include <qptrlist.h>
#include <qcheckbox.h>
#include "widget_ui_stitchProp.h"

class DrawInRepeat;
class ApaintDoc;

typedef struct {int left, right;} MinMaxPos;
typedef QPtrList<MinMaxPos> MinMaxHor;

class StitchPropWid:public StitchPropWidgetUI{
    Q_OBJECT
public:  
   StitchPropWid(QWidget *parent, const char *name);
   ~StitchPropWid(){};

   enum { Left, Right, LeftRight, LeftRight2, Up, Down, UpDown, UpDown2 };

   int getDirect();
   int getLen() {return sbLen->value();}
   void setLen(int val) {sbLen->setValue(val);}
   bool doStitchLine() {return cbStitchLine->isChecked();}
};

class StitchTool : public ToolBase {
  Q_OBJECT
public: 
	StitchTool(DrawInRepeat *drawp, ApaintDoc *docp, ToolType type, PropObject *propObj);
	~StitchTool();

  void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
  void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);

private:
  bool validPoint(int xin, int yin, uint col, int colPtr, ApaintImage& img, QImage& imgPix);
  QRect fill(int x, int y, QPainter *p, ApaintImage& img, QImage& imgPix);
  void setPixCol(int xin, int yin, QImage& imgPix);
  void setPosVal(MinMaxPos *mm, int val);
  void setPosVal(MinMaxHor& mm, int left, int right);
  bool isPosIn(MinMaxHor& mm, int x);
  void drawLeft(int ymin, int ymax,  QPainter *p);
  void drawRight(int ymin, int ymax, QPainter *p);
  void drawLeftRight(int ymin, int ymax, QPainter *p);
  void drawLeftRight2(int ymin, int ymax, QPainter *p);
  void drawUp(int xmin, int xmax, QPainter *p);
  void drawDown(int xmin, int xmax, QPainter *p);
  void drawUpDown(int xmin, int xmax, QPainter *p);
  void drawUpDown2(int xmin, int xmax, QPainter *p);
  void getSame(int posy, int &cnt);
  void clearLine(int ypos);
  void drawPoint(QPainter *p, int x, int y);

  
  QColor fgCol, bgCol;
  int fgIndx, bgIndx;
  ButtonState btnPressed;
  DrawInRepeat *draw;
  ApaintDoc *doc;
  bool *protCol;
  QImage imgPixMask;
  MinMaxPos *horPos;
  MinMaxHor *vertPos;
  StitchPropWid *stProp;
  bool wasBtnPressed;
  
};

#endif
