/***************************************************************************
                          writetool.h  -  description
                             -------------------
    begin                : Fri Mar 28 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WRITETOOL_H
#define WRITETOOL_H

#include <toolbase.h>
#include <qpainter.h>
#include <qtimer.h>
#include "apaintdoc.h"
#include "apaintview.h"

class TextFontSelect;
class QStringList;
class PenBrushUtil;
class DrawInRepeat;
class ApaintView;

class WriteTool : public ToolBase  {
  Q_OBJECT
public: 
	WriteTool(QWidget *parent, ToolType type, DrawInRepeat *drawp, ApaintDoc *docp, ApaintView *viewp, PenBrushUtil *pbUtilp,  PropObject *propObj);
	~WriteTool();

  virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mouseDoubleClick(QMouseEvent *e, QPainter *pc, QPainter *pi);
 // void keyPress(QKeyEvent *e, QPainter *pc, QPainter *pi);
  virtual void begin();
  virtual void end();
  virtual void showCommonProp(bool enable);

signals:
  void  setCursor(QCursor &cur);
  
public slots:
  void insertSlot();
  void closeIt();

protected:
  void beginTool();
  void endTool();
  void doOp(int x, int y);
    
private:

  bool drawStart;
  bool drawn;
  int lastx, lasty;
  TextFontSelect *fontDlg;
  ApaintDoc *doc;
  ApaintView *view;
  bool leftBtnDown, rightBtnDown, inArea;
  QCursor allCur;
  PenBrushUtil *pbUtil;
  DrawInRepeat *draw;
};

#endif
